/*Global Definitions of classes and some parameters*/

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <string>;
using namespace std;
typedef struct{
long int accountnumber;
char name[100];
int age;
char type;
char sex;
char occupation[20];
long double balance;
char address[256];
time_t seconds;
}customerinfo;
int infosize=sizeof (customerinfo);
long int a;

/*Creating new account function*/
//ERRORS:return 1-"file open error"
         
long int add_acc(char name[100],int age,char type,char sex,char occupation[20],long double opening_balance,char address[256]) 
{
FILE *fp;
customerinfo customer;


fp = fopen("Customer_Details.txt", "rb+");
if (fp == NULL){ return 1;}
//Take care about minimum opening balance,type and sex.
fread(&customer, infosize, 1, fp);
customer.accountnumber=customer.accountnumber+1;
int temp=customer.accountnumber;
fseek(fp,0,SEEK_SET);
fwrite(&customer, infosize, 1, fp);

customer.accountnumber=temp;
memcpy(customer.name,name,strlen(name)+1);
customer.age=age;
customer.type=type;

customer.sex=sex;

memcpy(customer.occupation,occupation,strlen(occupation)+1);
customer.balance=opening_balance;
memcpy(customer.address,address,strlen(address)+1);
customer.seconds=time(NULL);


fclose(fp);
fp=fopen("Customer_Details.txt","ab");
fwrite(&customer, infosize, 1, fp);

fclose (fp);
return customer.accountnumber;

}

/*Search function by A/c No.*/
/*ERRORS:return customer.age as -1 -"Please enter a valid account number!"    
		customer.age as -2 -"File open error"                                            */
customerinfo search_acc(long int accountnumber) 
{
FILE *fp;
customerinfo customer;


fp = fopen("Customer_Details.txt", "rb");
if (fp == NULL){ customer.age=-2; return customer;}


fread(&customer, infosize, 1, fp);
a=customer.accountnumber;
customer.age=-1;
if (accountnumber<=1000000 || accountnumber>a) {return customer;}
//this should display "Please enter a valid account number!"
else{
fseek(fp,infosize*(accountnumber-1000000),SEEK_SET);
fread(&customer, infosize, 1, fp);

fclose(fp);
return customer;
}
}

/*Deleting existing account function*/
/*ERRORS:return 1-"file open error"
         return 2-"Please enter a valid account number!"            */
int delete_acc(long int accountnumber) 
{
FILE *fp;
customerinfo customer;

fp = fopen("Customer_Details.txt", "rb+");
if (fp == NULL){return 1;}


fread(&customer, infosize, 1, fp);
a=customer.accountnumber;
if (accountnumber<=1000000 || accountnumber>a) {return 2;}
//this should display "Please enter a valid account number!"
else{
fseek(fp,infosize*(accountnumber-1000000),SEEK_SET);
fread(&customer, infosize,1,fp);
customer.age=-1;
customer.type=' ';
customer.sex=' ';
customer.balance=-1;
customer.seconds=time(NULL);
fseek(fp,-infosize,SEEK_CUR);
fwrite(&customer, infosize, 1, fp);

fclose(fp);
return 0;
}
}

/*Deposit Function*/
/*ERRORS:return 1-"file open error"
         return 2-"Please enter a valid account number!"            */
long double deposit_acc(long int accountnumber, long double deposit) 
{
FILE *fp;
customerinfo customer;

fp = fopen("Customer_Details.txt", "rb+");
if (fp == NULL){ return 1;}


fread(&customer, infosize, 1, fp);
a=customer.accountnumber;
if (accountnumber<=1000000 || accountnumber>a) {return 2;}
//this should display "Please enter a valid account number!"
else{
fseek(fp,infosize*(accountnumber-1000000),SEEK_SET);
fread(&customer, infosize, 1, fp);

customer.balance=customer.balance+deposit;
fseek(fp,-infosize,SEEK_CUR);
fwrite(&customer, infosize, 1, fp);

fclose(fp);
return customer.balance;
}
}

/*Withdrawal Function*/
/*ERRORS:return 1-"file open error"
         return 2-"Please enter a valid account number!"
         return 3-"Maximum Withdrawal Allowed is Rs.10000!"
         return 4-"Minimum Balance Required is Rs.500.Kindly Withdraw lesser amount!"            */
long double withdrawal_acc(long int accountnumber, long double withdrawal) 
{
FILE *fp;
customerinfo customer;

fp = fopen("Customer_Details.txt", "rb+");
if (fp == NULL){return 1;}


fread(&customer, infosize, 1, fp);
a=customer.accountnumber;
if (accountnumber<=1000000 || accountnumber>a) {return 2;}
//this should display "Please enter a valid account number!"
else{
fseek(fp,infosize*(accountnumber-1000000),SEEK_SET);
fread(&customer, infosize, 1, fp);
	if(customer.type=='s')
		{if (withdrawal>10000) return 3;//This should return "Maximum Withdrawal Allowed is Rs.10000!"
		 else{
			customer.balance=customer.balance-withdrawal;
			if (customer.balance<500) return 4;//This should return "Minimum Balance Required is Rs.500.Kindly Withdraw lesser amount!"
				
			fseek(fp,-infosize,SEEK_CUR);
			fwrite(&customer, infosize, 1, fp);
		     }
		}
	else {
		customer.balance=customer.balance-withdrawal;
		if (customer.balance<500) return 4;//This should return "Minimum Balance Required is Rs.500.Kindly Withdraw lesser amount!"
	
		fseek(fp,-infosize,SEEK_CUR);
		fwrite(&customer, infosize, 1, fp);
	     }	
fclose(fp);
return customer.balance;
}
}

/*Interest Computing Function*/
/*ERRORS:return 1-"file open error"
         return 2-"Please enter a valid account number!"*/
long double interest_acc(long int accountnumber) 
{
FILE *fp;
customerinfo customer;
int t;
fp = fopen("Customer_Details.txt", "rb+");
if (fp == NULL){return 1;}


fread(&customer, infosize, 1, fp);
a=customer.accountnumber;
if (accountnumber<=1000000 || accountnumber>a) {return 2;}
//this should display "Please enter a valid account number!"
else{fseek(fp,infosize*(accountnumber-1000000),SEEK_SET);
fread(&customer, infosize, 1, fp);

t=(time(NULL)-customer.seconds)/(15768000);

customer.balance*=(pow(1.04,t));
customer.seconds+=t*15768000;

fseek(fp,-infosize,SEEK_CUR);
fwrite(&customer, infosize, 1, fp);

fclose(fp);
return customer.balance;
}
}


