/*Global Definitions of classes and some parameters*/

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>

using namespace std;
typedef struct {
	long int accountnumber;
	char name[100];
	int age;
	char type;
	char occupation[20];
	long double balance;
	char address[256];
	time_t seconds;
}customerinfo;
int infosize=sizeof (struct customerinfo);

/*Creating new account function*/
int add(char name[100],int age,char type,char occupation[20],long double opening_balance,char address[256]) 
{
FILE *fp;
customerinfo customer;

fp = fopen("Customer_Details.txt", "rb");
if (fp == NULL){ cout << "file open error\n"; return 1;}

fread(&customer, infosize, 1, fp);
customer.accountnumber=customer.accountnumber+1;
fseek(fp,0,SEEK_SET);
fwrite(&customer, infosize, 1, fp);

memcpy(customer.name,name,strlen(name)+1);
customer.age=age;
customer.type=type;
memcpy(customer.occupation,occupation,strlen(occupation)+1);
customer.balance=opening_balance;
memcpy(customer.address,address,strlen(address)+1);
customer.seconds=time(NULL);

fclose(fp);
fp=fopen("Customer_Details.txt","ab");
fwrite(&customer, infosize, 1, fp);

fclose (fp);
return 0;
}

/*Search function by A/c No.*/
customerinfo * search_acc(long int accountnumber) 
{
FILE *fp;
customerinfo customer;

fp = fopen("Customer_Details.txt", "rb");
if (fp == NULL){ cout << "file open error\n"; return 1;}

fseek(fp,infosize*(acccountnumber-1000000),SEEK_SET);
fread(&customer, infosize, 1, fp);

fclose(fp);
return &customer;
}


/*Deleting existing account function*/
int delete_acc(long int accountnumber) 
{
FILE *fp;
customerinfo customer;

fp = fopen("Customer_Details.txt", "wb");
if (fp == NULL){ cout << "file open error\n"; return 1;}

fseek(fp,infosize*(acccountnumber-1000000),SEEK_SET);
fread(&customer, infosize,1,fp);
customer.name="";
customer.age=0;
customer.type="";
customer.occupation="";
customer.balance=-1;
customer.address="";
customer.seconds=time(NULL);
fseek(fp,-infosize,SEEK_CUR);
fwrite(&customer, infosize, 1, fp);

fclose(fp);
return 0;
}

/*Transaction Function*/
int transaction_acc(long int accountnumber, long double transaction) 
{
FILE *fp;
customerinfo customer;

fp = fopen("Customer_Details.txt", "wb+");
if (fp == NULL){ cout << "file open error\n"; return 1;}

fseek(fp,infosize*(acccountnumber-1000000),SEEK_SET);
fread(&customer, infosize, 1, fp);

customer.balance=customer.balance+transaction;
fseek(fp,-infosize,SEEK_CUR);
fwrite(&customer, infosize, 1, fp);

fclose(fp);
return 0;
}


/*Interest Computing Function*/
int interest_acc(long int accountnumber) 
{
FILE *fp;
customerinfo customer;
double t;
fp = fopen("Customer_Details.txt", "wb+");
if (fp == NULL){ cout << "file open error\n"; return 1;}

fseek(fp,infosize*(acccountnumber-1000000),SEEK_SET);
fread(&customer, infosize, 1, fp);

t=(time(NULL)-customer.seconds)/43200;
customer.balance*=(pow(1.08,t));

fseek(fp,-infosize,SEEK_CUR);
fwrite(&customer, infosize, 1, fp);

fclose(fp);
return 0;
}


